PROGRAM VA_version_3_0; { Supporte les lecteurs CD-ROMs }

USES
  Crt,Dos;

  PROCEDURE Aide;
    CONST
      Nom : ARRAY[1..42] OF INTEGER=
            (430,325,160,255,230,240,160,160,200,495,205,160,245,270,225,240,
             245,225,285,270,160,160,560,485,570,160,415,650,490,485,575,580,
             525,505,550,160,360,345,380,380,345,425);
    VAR
      i : BYTE;
    BEGIN
      WriteLn;
      FOR i:=1 TO 42 DO Write(Chr(Nom[i] DIV 5));
      WriteLn; WriteLn;
      WriteLn('  VA  [ nomrep | /A [rep [rep...]] | /? ]');
      WriteLn;
      WriteLn('   nomrep    nom (ou dbut du nom) d''un rpertoire du disque actuel sans chemin');
      Write('     /A      (re)construction du fichier VA.ARB ou VA_CD.ARB (arborescence) dans');
      WriteLn('             la racine du disque actuel (C:\ pour un CD-ROM)');
      WriteLn('     rep     ( utiliser avec l''option /A) indique le(s) rpertoire(s)  placer');
      WriteLn('             en premier dans le fichier d''arborescence.');
      WriteLn('             ces rpertoires ne doivent comporter aucun lecteur ni chemin.');
      WriteLn('             (tous les sous-rpertoires seront aussi placs en premier)');
      WriteLn;
      WriteLn('Si aucun paramtre n''est transmis en ligne de commande,la liste des rpertoires');
      WriteLn('est affiche et vous permet d''en choisir un.');
      WriteLn;
      WriteLn('Le fichier d''arborescence sera cr si lors de la recherche il n''est pas');
      WriteLn('prsent.');
      Halt(0)
    END;

  PROCEDURE Erreur(Message : STRING);
    BEGIN
      WriteLn;
      WriteLn(^G+'ERREUR: ',Message);
      Halt(1)
    END;

TYPE
  T_REP = STRING[65];

VAR
  Rep       : ARRAY[1..10000] OF ^T_REP;  { Rpertoires stocks en mmoire }
  Rep_enreg : STRING;                     { Rpertoire actuellement trait }
  Rep_init  : STRING;                     { Rpertoire initial }
  En_tete   : STRING[3];                  { Disque+':\', ex: 'C:\' }
  Cd_rom    : BOOLEAN;                    { True si on est sur un lect. CD-rom }

CONST
  NbRep : INTEGER = 0;
  NomFich_ARB : STRING = 'VA.ARB';

  PROCEDURE Trie_reps(Debut,Fin : WORD);
    VAR
      i,j : INTEGER;
      x,y : T_REP;
    BEGIN
      i:=Debut; j:=Fin; x:=Rep[(Debut+Fin) DIV 2]^;
      REPEAT
        WHILE Rep[i]^<x DO i:=i+1;
        WHILE x<Rep[j]^ DO j:=j-1;
        IF i<=j THEN
          BEGIN
            y:=Rep[i]^; Rep[i]^:=Rep[j]^; Rep[j]^:=y;
            i:=i+1; j:=j-1
          END
      UNTIL i>j;
      IF Debut<j THEN Trie_reps(Debut,j);
      IF i<Fin THEN Trie_reps(i,Fin)
    END;

  FUNCTION Volume_sans_point(Nom_volume : STRING) : STRING;
    VAR
      i : BYTE;
    BEGIN
      i:=Pos('.',Nom_volume);
      IF i<>0 THEN
        Volume_sans_point:=Copy(Nom_volume,1,i-1)+
          Copy(Nom_volume,i+1,Length(Nom_volume)-i)
      ELSE
        Volume_sans_point:=Nom_volume
    END;

  PROCEDURE Choix_repertoire;
    VAR
      Ecran    : ARRAY[1..4096] OF BYTE;  { Ecran du Dos sauv }
      x,y      : BYTE;      { Coordonnes sauves }
      Curseur  : WORD;      { Curseur sauv }
      Fichier  : TEXT;      { Fichier VA.ARB (ou VA_CD.ARB) }
      Repert   : STRING;    { Rpertoires lus un par un dans cette variable }
      Volume_CD: STRING[12];{ Nom de volume du CD }
      Debut    : INTEGER;   { Rang du 1er rpertoire affich  l'cran }
      k        : CHAR;      { Touche lue }
    PROCEDURE Affiche;
      BEGIN
        GotoXY(5,13);
        TextBackGround(LightBlue);
        Write(Rep[Debut+11]^);
        TextBackGround(Black)
      END;
    PROCEDURE Efface;
      BEGIN
        GotoXY(5,13);
        Write(Rep[Debut+11]^)
      END;
    PROCEDURE Affiche_reps;
      VAR
        i : LONGINT;
      BEGIN
        Window(1,1,65,25);
        FOR i:=Debut TO Debut+23 DO
          BEGIN
            GotoXY(5,i-Debut+2); ClrEol;
            IF (i<=NbRep) AND (i>0) THEN Write(Rep[i]^)
          END;
        Window(1,1,80,25);
        Affiche
      END;
    CONST
      Nom : ARRAY[1..20] OF INTEGER=
            (430,325,160,255,230,240,160,560,485,570,160,415,230,360,345,380,
             380,345,425,160);
    VAR
      i : WORD;
      DirInfo : SEARCHREC;
    BEGIN
      Assign(Fichier,En_tete+NomFich_ARB);
      {$i-} Reset(Fichier); {$i+}
      IF IOResult<>0 THEN
        Erreur('lecture impossible du fichier '+En_tete+NomFich_ARB);
      IF CD_rom THEN
        BEGIN
          ReadLn(Fichier,Volume_CD);
          FindFirst(Rep_init,VolumeID,DirInfo);
          IF Volume_CD<>DirInfo.Name THEN
            BEGIN
              Close(Fichier);
              Erreur('le fichier VA_CD.ARB ('+Volume_sans_point(Volume_CD)+
                ') ne correspond pas avec le CD prsent'+#13+#10+
                '        dans le lecteur ('+
                Volume_sans_point(DirInfo.Name)+')')
            END
        END;
      REPEAT
        Inc(NbRep);
        New(Rep[NbRep]);
        ReadLn(Fichier,Rep[NbRep]^);
      UNTIL Eof(Fichier);
      IF NbRep=0 THEN
        Erreur('le fichier '+En_tete+NomFich_ARB+' est invalide');
      Trie_reps(1,NbRep);
      Debut:=-999;
      FOR i:=1 TO NbRep DO
        IF Copy(Rep_Init,1,3)+Rep[i]^=Rep_Init THEN Debut:=i-11;
      IF Debut=-999 THEN
        BEGIN
          IF Length(Rep_init)>3 THEN
            BEGIN
              WriteLn;
              WriteLn(^G+'Le rpertoire '+Rep_Init+' n''est pas dans le fichier VA.ARB.');
              WriteLn('Mettez  jour le fichier d''arborescence.');
              WriteLn('(Tapez VA/? pour l''aide)');
              Halt(1)
            END
          ELSE
            Debut:=-10;
        END;
      Move(Mem[$B800:0],Ecran,4096); x:=WhereX; y:=WhereY;
      ASM
        mov ah,03h; xor bh,bh; int 10h; mov Curseur,cx  {sauve le curseur}
        mov ah,01h; mov cx,2008h; int 10h {installe un curseur vide}
      END;
      TextColor(LightGray); TextBackGround(Black); Window(1,1,80,25); ClrScr;
      TextColor(Red); TextBackGround(LightCyan);
      GotoXY(1,1);
      Write(' CHOISISSEZ VOTRE REPERTOIRE: ('+Chr(24)+','+Chr(25)+',PgUp,PgDn,Dbut,Fin)     ');
      FOR i:=1 TO 20 DO Write(Chr(Nom[i] DIV 5));
      TextBackGround(Black);
      TextColor(LightRed+128); GotoXY(1,13); Write('>>>'); TextColor(LightGray);
      GotoXY(72,3); Write('Disque '+Rep_Init[1]+':');
      IF CD_rom THEN
        BEGIN
          {i:=Pos('.',Volume_CD);
          IF i<>0 THEN
            Volume_CD:=Copy(Volume_CD,1,i-1)+
              Copy(Volume_CD,i+1,Length(Volume_CD)-i);}
          Volume_CD:=Volume_sans_point(Volume_CD);
          GotoXY(81-Length(Volume_CD),5); Write(Volume_CD)
        END;
      Affiche_reps;
      REPEAT
        k:=UpCase(ReadKey);
        IF k=#0 THEN
          BEGIN
            k:=ReadKey;
            CASE k OF
              'H':IF Debut>-10 THEN
                    BEGIN
                      Efface; Dec(Debut);
                      ASM
                        mov ax,0701h; xor bh,bh; mov cx,0104h;
                        mov dx,1844h; int 10h
                      END;
                      IF Debut>0 THEN
                        BEGIN GotoXY(5,2); Write(Rep[Debut]^) END;
                      Affiche
                    END;
              'P':IF Debut<NbRep-11 THEN
                    BEGIN
                      Efface; Inc(Debut);
                      ASM
                        mov ax,0601h; xor bh,bh; mov cx,0104h;
                        mov dx,1844h; int 10h
                      END;
                      IF Debut+23<=NbRep THEN
                        BEGIN GotoXY(5,25); Write(Rep[Debut+23]^) END;
                      Affiche
                  END;
              'G':IF Debut>-10 THEN
                    BEGIN Debut:=-10; Affiche_reps; Affiche END;
              'O':IF Debut<NbRep-11 THEN
                    BEGIN Debut:=NbRep-11; Affiche_reps; Affiche END;
              'I':IF Debut-24>=-10 THEN
                    BEGIN Dec(Debut,24); Affiche_reps; Affiche END
                  ELSE
                    IF Debut>-10 THEN
                      BEGIN Debut:=-10; Affiche_reps END;
              'Q':IF Debut+24<=NbRep-11 THEN
                    BEGIN Inc(Debut,24); Affiche_reps END
                  ELSE
                    IF Debut<NbRep-11 THEN
                      BEGIN Debut:=NbRep-11; Affiche_reps END;
            END
          END
        ELSE
          BEGIN
            CASE k OF
              #3,#27:BEGIN
                       TextMode(3);
                       Move(Ecran,Mem[$B800:0],4096);
                       GotoXY(x,y);
                       ASM mov ah,01h; mov cx,Curseur; int 10h END;
                       Halt(0)
                     END;
              #13:BEGIN
                    TextMode(3);
                    Move(Ecran,Mem[$B800:0],4096);
                    GotoXY(x,y);
                    ASM mov ah,01h; mov cx,Curseur; int 10h END;
                    {$i-} ChDir(Copy(Rep_Init,1,3)+Rep[Debut+11]^); {$i+}
                    IF IOResult<>0 THEN
                      BEGIN
                        WriteLn;
                        WriteLn(^G+'Le rpertoire '+Copy(Rep_Init,1,3)+
                          Rep[Debut+11]^+' n''existe plus.');
                        WriteLn('Mettez  jour le fichier d''arborescence.');
                        Halt(1)
                      END;
                    Halt(0)
                  END;
            END
          END
      UNTIL False;
    END;

  PROCEDURE Is_CD_ROM; ASSEMBLER;
    ASM
      mov ax,150Bh            { fct 15h,ss-fct 0Bh: dterminer si un lecteur }
                              { est un CD-ROM gr par MSCDEX }
      mov si,offset Rep_Init  { SI pointe sur Rep_Init[0] }
      inc si                  { SI pointe sur Rep_Init[1] }
      xor ch,ch               { CH <-- 0 }
      mov cl,[si]             { CL <-- RepInit[1] }
      sub cl,65
      int 2fh                 { Interruption 2Fh (MSCDEX) }
      cmp bx,0ADADh           { Signature de MSCDEX en retour ? }
      jne @pas_CD             { Non ==> MSCDEX pas install }
      cmp ax,0                { AX = 0 (pas un lecteur CD-ROM) ? }
      je @pas_CD              { Oui ==> lecteur en cours n'est pas un CD-ROM }
      mov CD_rom,1            { quivaut  CD_rom:=True }
      jmp @fin
      @pas_CD:
      mov CD_rom,0            { quivaut  CD_rom:=False }
      @fin:
    END;

  FUNCTION Touche : CHAR;
    BEGIN
      Touche:=ReadKey
    END;

  PROCEDURE Lit_reps_recurs(Repertoire : STRING);
    VAR
      DirInfo : SEARCHREC;
    BEGIN
      IF KeyPressed THEN
        IF Touche IN [#3,#27] THEN
          BEGIN
            ChDir(Rep_Init);
            Erreur('lecture des rpertoires interrompue, fichier '+En_tete+NomFich_ARB+' non crit')
          END;
      {$i-} ChDir(Repertoire); {$i+}
      IF IOResult=0 THEN
        BEGIN
          GetDir(0,Rep_enreg);
          IF Length(Rep_enreg)>3 THEN
            BEGIN
              Inc(NbRep);
              GotoXY(28,WhereY); Write(NbRep);
              New(Rep[NbRep]);
              Rep[NbRep]^:=Copy(Rep_enreg,4,Length(Rep_enreg)-3)
            END;
          FindFirst('*.*',AnyFile,DirInfo);
          WHILE DosError=0 DO
            BEGIN
              IF (DirInfo.Name<>'.') AND (DirInfo.Name<>'..')
                AND (DirInfo.Attr AND Directory<>0) THEN
                Lit_reps_recurs(DirInfo.Name);
              FindNext(DirInfo)
            END;
          GetDir(0,Rep_enreg);
          IF Length(Rep_enreg)>3 THEN ChDir('..')
        END
      ELSE
        BEGIN
          GotoXY(1,WhereY); ClrEol;
          WriteLn(^G+'ERREUR: dplacement impossible vers le rpertoire "'+Repertoire+'"...');
          WriteLn('Un ou plusieurs rpertoires seront absents du fichier d''arborescence...');
          Write('Lecture des rpertoires... ')
        END
    END;

  PROCEDURE Ecrit_arbre_dans_VA_ARB;
    VAR
      Fichier : TEXT;  { Fichier VA.ARB de type texte }
      i       : WORD;
      DirInfo : SEARCHREC;
    BEGIN
      Assign(Fichier,En_tete+NomFich_ARB);
      {$i-} ReWrite(Fichier); {$i+}
      IF IOResult<>0 THEN
        Erreur('criture impossible du fichier '+En_tete+NomFich_ARB);
      IF CD_rom THEN
        BEGIN
          FindFirst(Rep_Init,VolumeID,DirInfo);
          WriteLn(Fichier,DirInfo.Name)
        END;
      FOR i:=1 TO NbRep DO
        BEGIN
          WriteLn(Fichier,Rep[i]^);
          Dispose(Rep[i])
        END;
      Close(Fichier)
    END;

  FUNCTION Maj(St : STRING) : STRING;
    VAR
      i : BYTE;
    BEGIN
      FOR i:=1 TO Length(St) DO St[i]:=UpCase(St[i]);
      Maj:=St
    END;

  PROCEDURE Place_reps_en_premier;
    VAR
      i     : BYTE;
      j,k   : WORD;
      Ch    : STRING;
      NbDep : WORD;
      Temp  : T_REP;
    BEGIN
      FOR i:=ParamCount DOWNTO 2 DO
        BEGIN
          Ch:=Maj(ParamStr(i));
          NbDep:=0;
          j:=NbRep;
          REPEAT
            IF ((Rep[j]^=Ch) OR (Copy(Rep[j]^,1,Length(Ch)+1)=Ch+'\'))
              AND (j>1) THEN
              BEGIN
                Temp:=Rep[j]^;
                FOR k:=j DOWNTO 2 DO Rep[k]^:=Rep[k-1]^;
                Rep[1]^:=Temp;
                Inc(NbDep)
              END
            ELSE
              Dec(j)
          UNTIL j=NbDep+1;
          IF NbDep=0 THEN Erreur('rpertoire '+Ch+' incorrect, fichier '+En_tete+NomFich_ARB+' non crit');
        END;
      FOR i:=2 TO ParamCount DO
        BEGIN
          Write(#13,#10,'Rpertoire '+Maj(ParamStr(i))+' plac en ',i-1);
          IF i-1=1 THEN
            Write('er')
          ELSE
            Write('me')
        END
    END;

  PROCEDURE Creation_VA_ARB;
    VAR
      i : BYTE;
    BEGIN
      IF ParamCount>1 THEN
        BEGIN
          FOR i:=ParamCount DOWNTO 2 DO
            BEGIN
              ChDir('\');
              {$i-} ChDir(ParamStr(i)); {$i+}
              IF IOResult<>0 THEN
                BEGIN
                  ChDir(Rep_Init);
                  Erreur('rpertoire '+Maj(ParamStr(i))+' incorrect, fichier '+En_tete+NomFich_ARB+' non crit')
                END
            END;
          ChDir(Rep_Init)
        END;
      GetDir(0,Rep_init);
      WriteLn;
      Write('Lecture des rpertoires... ');
      Lit_reps_recurs(Copy(Rep_Init,1,3));  { Lit rcursivement les rp. }
      IF NbRep=0 THEN
        Erreur('aucun rpertoire sur ce disque');
      ChDir(Rep_init);
      IF ParamCount>1 THEN
        Place_reps_en_premier;  { Place les rpertoires demands en premier }
      Ecrit_arbre_dans_VA_ARB;  { Ecrit l'arbre ainsi form dans VA.ARB }
      WriteLn
    END;

  PROCEDURE Lit_VA_ARB;
    VAR
      Fichier   : TEXT;
      Volume_CD : STRING[12];
      DirInfo   : SEARCHREC;
    BEGIN
      Assign(Fichier,En_tete+NomFich_ARB);
      {$i-} Reset(Fichier); {$i+}
      IF IOResult<>0 THEN
        BEGIN
          Creation_VA_ARB;
          {$i-} Reset(Fichier); {$i+}
          IF IOResult<>0 THEN
            Erreur('lecture impossible du fichier '+En_tete+NomFich_ARB)
        END;
      IF CD_rom THEN
        BEGIN
          ReadLn(Fichier,Volume_CD);
          FindFirst(Rep_init,VolumeID,DirInfo);
          IF Volume_CD<>DirInfo.Name THEN
            BEGIN
              Close(Fichier);
              Erreur('le fichier VA_CD.ARB ('+Volume_sans_point(Volume_CD)+
                ') ne correspond pas avec le CD prsent'+#13+#10+
                '        dans le lecteur ('+
                Volume_sans_point(DirInfo.Name)+')')
            END
        END;
      NbRep:=0;
      REPEAT
        Inc(NbRep);
        New(Rep[NbRep]);
        ReadLn(Fichier,Rep[NbRep]^)
      UNTIL Eof(Fichier);
      Close(Fichier)
    END;

  PROCEDURE Deplace_vers_repertoire;
    VAR
      i,j        : WORD;
      Repertoire : T_REP;
    FUNCTION Pos_fin(Str1,Str2 : STRING) : BYTE;
      VAR
        i : BYTE;
      BEGIN
        i:=Length(Str2);
        WHILE (i>0) AND (Copy(Str2,i,Length(Str1))<>Str1) DO Dec(i);
        Pos_fin:=i
      END;

    FUNCTION Ok_rep : BOOLEAN;
      VAR
        Position : BYTE;
      BEGIN
        Position:=Pos_fin('\'+Repertoire,Rep[i]^);
        {IF ((Position=0) AND (Pos(Repertoire,Rep[i]^)=0))
          OR (Pos('\',Copy(Rep[i]^,Position+1,Length(Rep[i]^)-Position))<>0)}
        IF ((Position>1)
          AND (Pos('\',Copy(Rep[i]^,Position+1,Length(Rep[i]^)-Position))=0))
          OR ((Pos_fin(Repertoire,Rep[i]^)=1) AND (Pos('\',Rep[i]^)=0)) THEN
          Ok_rep:=True
        ELSE
          Ok_rep:=False
      END;

    PROCEDURE Va_vers(Repertoire : STRING);
      BEGIN
        {$i-} ChDir(Repertoire); {$i+}
        IF IOResult<>0 THEN
          BEGIN
            WriteLn;
            WriteLn(^G+'Le rpertoire '+Repertoire+' n''existe plus.');
            WriteLn('Mettez  jour le fichier d''arborescence.');
            Halt(1)
          END;
        Halt(0)
      END;
    BEGIN
      Repertoire:=ParamStr(1);
      FOR i:=1 TO Length(Repertoire) DO Repertoire[i]:=UpCase(Repertoire[i]);
      i:=0;
      REPEAT Inc(i) UNTIL (Copy(Rep_Init,1,3)+Rep[i]^=Rep_init) OR (i=NbRep);
      IF NOT Ok_rep THEN i:=0;
      IF i<NbRep THEN
        BEGIN
          REPEAT
            Inc(i);
            IF Ok_rep THEN Va_vers(Copy(Rep_Init,1,3)+Rep[i]^)
          UNTIL i=NbRep
        END;
      i:=0;
      REPEAT
        Inc(i);
        IF Ok_rep THEN Va_vers(Copy(Rep_Init,1,3)+Rep[i]^)
      UNTIL (Copy(Rep_Init,1,3)+Rep[i]^=Rep_init) OR (i=NbRep);
      Sound(200); Delay(1); NoSound;
      Halt(1)
    END;

BEGIN
  CheckBreak:=False;
  IF ParamStr(1)='/?' THEN Aide;
  IF ParamStr(1)='\' THEN
    BEGIN ChDir('\'); Halt(0) END;
  GetDir(0,Rep_init);
  Is_CD_Rom;
  IF CD_rom THEN
    BEGIN
      En_tete:='C:\';
      NomFich_ARB:='VA_CD.ARB'
    END
  ELSE
    En_tete:=Copy(Rep_init,1,3);
  IF ParamCount=0 THEN Choix_repertoire;
  IF (ParamStr(1)='/a') OR (ParamStr(1)='/A') THEN
    Creation_VA_ARB
  ELSE
    BEGIN
      Lit_VA_ARB;                   { Lecture du fichier VA.ARB }
      Deplace_vers_repertoire       { On se dplace vers le rpertoire demand }
    END
END.